| darcs-2.4.4: a distributed, interactive, smart revision control system | Source code | Contents | Index

Darcs.Witnesses.Ordered

Documentation

data EqCheck where | Source

Constructors

IsEq :: EqCheck |
NotEq :: EqCheck |

Instances

Eq EqCheck
Show EqCheck

isEq :: EqCheck -> Bool | Source

data a1 :> a2 | Source

Constructors

a1 :> a2 |

Instances

(Show2 a, Show2 b) => Show (a :> b)
(Show2 a, Show2 b) => Show2 (a :> b)

data a1 :< a2 | Source

Constructors

a1 :< a2 |

data a1 :\/: a2 | Source

Constructors

a1 :\/: a2 |

Instances

(Show2 a, Show2 b) => Show (a :\/: b)
(Show2 a, Show2 b) => Show2 (a :\/: b)

data a1 :/\: a2 | Source

Constructors

a1 :/\: a2 |

data a1 :||: a2 | Source

Constructors

a1 :||: a2 |

data FL a where | Source

Constructors

:>: :: a -> FL a -> FL a |
NilFL :: FL a |

Instances

Show2 a => Show (FL a)
Show2 a => Show2 (FL a)
(MyEq p, Commute p) => MyEq (FL p)
(Invert p, Commute p) => Invert (FL p)
ReadPatch p => ReadPatch (FL p)
(Conflict p, Apply p, Effect p, ShowPatch p) => ShowPatch (FL p)
Commute p => Commute (FL p)
Apply p => Apply (FL p)
(Conflict p, Patchy p) => Patchy (FL p)
Effect p => Effect (FL p)
Conflict p => Conflict (FL p)
FromPrim p => FromPrims (FL p)
RepoPatchBase p => RepoPatch (FL p)

data RL a where | Source

Constructors

:<: :: a -> RL a -> RL a |
NilRL :: RL a |

Instances

(MyEq p, Commute p) => MyEq (RL p)
(Commute p, Invert p) => Invert (RL p)
ReadPatch p => ReadPatch (RL p)
(Conflict p, Apply p, ShowPatch p) => ShowPatch (RL p)
Commute p => Commute (RL p)
Apply p => Apply (RL p)
(Conflict p, Patchy p) => Patchy (RL p)
Effect p => Effect (RL p)
Conflict p => Conflict (RL p)
FromPrim p => FromPrims (RL p)

data Proof a where | Source

Constructors

Proof :: a -> Proof a |

unsafeUnFL :: FL a -> [a] | Source

unsafeFL :: [a] -> FL a | Source

unsafeRL :: [a] -> RL a | Source

unsafeUnRL :: RL a -> [a] | Source

lengthFL :: FL a -> Int | Source

mapFL :: (a -> b) -> FL a -> [b] | Source

mapFL_FL :: (a -> b) -> FL a -> FL b | Source

spanFL :: (a -> Bool) -> FL a -> FL a :> FL a | Source

foldlFL :: (a -> b -> a) -> a -> FL b -> a | Source

allFL :: (a -> Bool) -> FL a -> Bool | Source

splitAtFL :: Int -> FL a -> FL a :> FL a | Source

bunchFL :: Int -> FL a -> FL (FL a) | Source

foldlRL :: (a -> b -> a) -> a -> RL b -> a | Source

lengthRL :: RL a -> Int | Source

isShorterThanRL :: RL a -> Int -> Bool | Source

mapRL :: (a -> b) -> RL a -> [b] | Source

mapRL_RL :: (a -> b) -> RL a -> RL b | Source

zipWithFL :: (a -> p -> q) -> [a] -> FL p -> FL q | Source

unsafeMap_l2f :: (a -> b) -> [a] -> FL b | Source

filterE :: (a -> EqCheck) -> [a] -> [Proof a] | Source

filterFL :: (p -> EqCheck) -> FL p -> FL p | Source

reverseFL :: FL a -> RL a | Source

reverseRL :: RL a -> FL a | Source

(+>+) :: FL a -> FL a -> FL a | Source

(+<+) :: RL a -> RL a -> RL a | Source

nullFL :: FL a -> Bool | Source

concatFL :: FL (FL a) -> FL a | Source

concatRL :: RL (RL a) -> RL a | Source

concatReverseFL :: FL (RL a) -> RL a | Source

headRL :: RL a -> FlippedSeal a | Source

class MyEq p where | Source

Methods

unsafeCompare :: p -> p -> Bool | Source

(=\/=) :: p -> p -> EqCheck | Source

(=/\=) :: p -> p -> EqCheck | Source

Instances

MyEq DirPatchType
MyEq FilePatchType
MyEq Prim
MyEq Patch
MyEq RealPatch
(MyEq p, Commute p) => MyEq (RL p)
(MyEq p, Commute p) => MyEq (FL p)
MyEq p => MyEq (Named p)
MyEq p => MyEq (PatchInfoAnd p)
MyEq p => MyEq (PatchChoice p)
MyEq p => MyEq (TaggedPatch p)

consRLSealed :: a -> FlippedSeal (RL a) -> FlippedSeal (RL a) | Source

nullRL :: RL a -> Bool | Source

unsafeCoerceP :: a -> a | Source

unsafeCoerceP2 :: t -> t | Source

Produced by Haddock version 2.4.2